'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref) {
  var t = _ref.types;

  return {
    visitor: {
      ClassDeclaration: function ClassDeclaration(path) {
        if (!path.node.decorators) {
          return;
        }
        var inject = path.node.decorators.find(function (decorator) {
          return decorator.expression.callee.name === 'Inject';
        });

        if (!inject) {
          return;
        }
        path.node.decorators = path.node.decorators.splice(path.node.decorators.indexOf(inject), 1);

        var toInject = inject.expression.arguments.map(function (arg) {
          return arg.value;
        });
        var ctor = path.node.body.body.find(function (el) {
          return el.kind === 'constructor';
        });
        var toParam = undefined;

        if (!ctor) {
          ctor = t.classMethod('constructor', t.identifier('constructor'), [], t.blockStatement([]));
          path.node.body.body.unshift(ctor);
          toParam = toInject;
        } else {
          toParam = toInject.filter(function (param) {
            return !ctor.params.find(function (p) {
              return p.name === param;
            });
          });
        }

        toParam.forEach(function (i) {
          ctor.body.body.unshift(t.expressionStatement(t.assignmentExpression('=', t.memberExpression(t.thisExpression(), t.identifier(i)), t.identifier(i))));
        });

        ctor.params = ctor.params.concat(toParam.map(function (i) {
          return t.identifier(i);
        }));

        path.insertAfter(t.expressionStatement(t.assignmentExpression('=', t.memberExpression(t.identifier(path.node.id.name), t.identifier('$inject')), t.arrayExpression(toInject.map(function (d) {
          return t.stringLiteral(d);
        })))));
      }
    }
  };
};

;